# Commitizen Automation

This project provides an automated environment for installing, configuring, and testing [Commitizen](https://commitizen-tools.github.io/commitizen/), a tool that helps in creating conventional commits. It utilizes Python, Taskfile, and CodeceptJS for automation, configuration, and testing.

## Table of Contents

- [Commitizen Automation](#commitizen-automation)
  - [Table of Contents](#table-of-contents)
  - [Getting Started](#getting-started)
    - [Prerequisites](#prerequisites)
    - [Setup with Taskfile](#setup-with-taskfile)
  - [Usage](#usage)
  - [Running Tests](#running-tests)
  - [Copier Configuration](#copier-configuration)
  - [CI/CD Integration](#cicd-integration)
  - [Development Environment](#development-environment)
  - [Contributing](#contributing)
  - [License](#license)

## Getting Started

These instructions will get you a copy of the project up and running on your local machine for development and testing purposes.

### Prerequisites

- **Python 3.11**: Managed via a version manager like `pyenv`.
- **Node.js**: For running behavioral tests with CodeceptJS.

### Setup with Taskfile

1. **Clone the Repository**: Clone this repository to your local machine and navigate to the project root.
2. **Install Commitizen**: Run `task commitizen:install` to install Commitizen and its dependencies. This setup includes creating a Python virtual environment, installing Commitizen, and configuring a symbolic link for the `cz` command in `~/.local/bin`.

## Usage

After installation, Commitizen can be utilized in two ways:

1. **Via the Virtual Environment**: Directly execute Commitizen using `<project_path>/.venv/commitizen/bin/cz`.
2. **Via the Symbolic Link**: Use the `cz` command from any directory, leveraging the symbolic link in `~/.local/bin`.

## Running Tests

To ensure everything is set up correctly:

1. Navigate to the project root.
2. Run the tests with `task tests`. This will verify the successful installation of Commitizen and its ability to run `cz version` from any location.

## Copier Configuration

This project uses Copier for configuration management. Changes to configuration should be made in the `copier.yml` and the `.config/commitizen/copier-answers.yml.jinja` files. Direct edits in the configurations generated by Copier are discouraged as they will be overwritten upon the next Copier run.

## CI/CD Integration

The `.gitlab-ci.yml` file defines the CI/CD pipeline configuration for GitLab. This setup includes conditions for running the pipeline on the main branch, tags, and merge requests. The `devsecops` stage executes tasks defined in the `Taskfile.yml`, utilizing Docker services.

## Development Environment

The `.gitpod.yml` specifies the Gitpod configuration, using a custom Docker image (`registry.gitlab.com/neosoft-group/practice/devops/public/hub/tools/gitpod/ubuntu:latest`) to ensure a consistent development environment.

## Contributing

We welcome contributions to this project. Here's how to contribute:

1. Fork the repository.
2. Create a new branch for your feature or bug fix.
3. Commit your changes using Commitizen (`cz commit`).
4. Push your branch to your fork.
5. Submit a Pull Request with a description of your changes.

## License

This project is licensed under the MIT License - see the [LICENSE](LICENSE) file for details.
